<!DOCTYPE HTML>
<html>
    <head>
        <meta charset="utf8">
        <title>Scratch Forum Post Statistics</title>
        <script src="https://d3js.org/d3.v4.js"></script>
        <script src="https://d3js.org/d3-scale-chromatic.v1.min.js"></script>
        <link href="https://fonts.googleapis.com/css2?family=Roboto:ital,wght@0,400;0,700;1,400;1,700&display=swap" rel="stylesheet">
        <link href="style.css" rel="stylesheet">
    </head>
    <body>
        <div id="top_text" style="margin: auto; text-align: center; margin-bottom: 5px;">
            Scratch Forum Leaderboards
        </div>
        <div id="top_text_2" style="margin: auto; text-align: center; margin-bottom: 15px;">
            ^^^^ (This is what it's called by the way) ^^^^
        </div>
        <div id="heading">
        </div>
        <div id="container">
            <div id="navigation">
                <a href="index.html?category=total">Forum Categories</a>
                <a href="user.html?user=CatsUnited">Users</a>
                <a href="https://my-ocular.jeffalo.net/login">Customise Profile (myocular)</a>
            </div>
            <form action="" method="get">
                <select name="category">
                    <option value="total">All Posts</option>
                    <optgroup label="Welcome to Scratch">
                        <option value="Announcements">Announcements</option>
                        <option value="New Scratchers">New Scratchers</option>
                    </optgroup>
                    <optgroup label="Making Scratch Projects">
                        <option value="Help With Scripts">Help With Scripts</option>
                        <option value="Show and Tell">Show and Tell</option>
                        <option value="Project Ideas">Project Ideas</option>
                        <option value="Collaboration">Collaboration</option>
                        <option value="Requests">Requests</option>
                    </optgroup>
                    <optgroup label="About Scratch">
                        <option value="Questions about Scratch">Questions about Scratch</option>
                        <option value="Suggestions">Suggestions</option>
                        <option value="Bugs and Glitches">Bugs and Glitches</option>
                        <option value="Advanced Topics">Advanced Topics</option>
                        <option value="Connecting to the Physical World">Connecting to the Physical World</option>
                        <option value="Developing Scratch Extensions">Developing Scratch Extensions</option>
                        <option value="Open Source Projects">Open Source Projects</option>
                    </optgroup>
                    <optgroup label="Interests Beyond Scratch">
                        <option value="Things I'm Making and Creating">Things I'm Making and Creating</option>
                        <option value="Things I'm Reading and Playing">Things I'm Reading and Playing</option>
                    </optgroup>
                    <optgroup label="Scratch Around the World">
                        <option value="Africa">Africa</option>
                        <option value="Bahasa Indonesia">Bahasa Indonesia</option>
                        <option value="Català">Català</option>
                        <option value="Deutsch">Deutsch</option>
                        <option value="Ελληνικά">Ελληνικά</option>
                        <option value="Español">Español</option>
                        <option value="فارسی">فارسی</option>
                        <option value="Français">Français</option>
                        <option value="עברית">עברית</option>
                        <option value="한국어">한국어</option>
                        <option value="Italiano">Italiano</option>
                        <option value="Nederlands">Nederlands</option>
                        <option value="日本語">日本語</option>
                        <option value="Norsk">Norsk</option>
                        <option value="Polski">Polski</option>
                        <option value="Português">Português</option>
                        <option value="Pусский">Pусский</option>
                        <option value="Türkçe">Türkçe</option>
                        <option value="中文">中文</option>
                        <option value="Other Languages">Other Languages</option>
                        <option value="Translating Scratch">Translating Scratch</option>
                    </optgroup>

                </select>
                <input type="submit" value="Go">
            </form>
            <div id="footer">
                <div>The full dataset for <a href="tfhgraph.mp4">The Forum Helpers Post Count History</a> is available <a href="postleaderboard.csv">here (CSV file)</a>.</a></div>
            </div>
            <div id="footer">
                <div>Made by <a href="https://scratch.mit.edu/users/CatsUnited">CatsUnited</a></div>
                <div>Data from <a href="https://scratchdb.lefty.one/">ScratchDB</a> by <a href="https://scratch.mit.edu/users/DatOneLefty">DatOneLefty</a></div>
            </div>
            <div id="loadingtext">Loading</div>
            <div id="content">
            </div>
        </div>
        <script>
            const urlparams = new URLSearchParams(window.location.search);
            let selectedCategory = urlparams.get("category");
            var currentpage = 0;

            if (selectedCategory == "Dustbin")  {
                window.location.href = "https://scratch.mit.edu/discuss/youtube/nSW6scUfnFw/";
            }
            if (selectedCategory == null)   {
                selectedCategory = "total";
            }
            function HSVtoRGB(h, s, v) {
                var r, g, b, i, f, p, q, t;
                if (arguments.length === 1) {
                    s = h.s, v = h.v, h = h.h;
                }
                i = Math.floor(h * 6);
                f = h * 6 - i;
                p = v * (1 - s);
                q = v * (1 - f * s);
                t = v * (1 - (1 - f) * s);
                switch (i % 6) {
                    case 0: r = v, g = t, b = p; break;
                    case 1: r = q, g = v, b = p; break;
                    case 2: r = p, g = v, b = t; break;
                    case 3: r = p, g = q, b = v; break;
                    case 4: r = t, g = p, b = v; break;
                    case 5: r = v, g = p, b = q; break;
                }
                return {
                    r: Math.round(r * 255),
                    g: Math.round(g * 255),
                    b: Math.round(b * 255)
                };
            }
            dectoHex = (num) => {
                return num.toString(16);
            }
            titletext = document.createElement("div");
            titletext.setAttribute("id", "titletext");
            if (selectedCategory != "total")    {
                titletext.appendChild(document.createTextNode("The Top Posters in " + selectedCategory));
            } else  {
                titletext.appendChild(document.createTextNode("The Top Posters of the Scratch Forums"));
            }
            document.getElementById("heading").appendChild(titletext);
            loadUserPosts(0);
            
            function loadUserPosts(page)    {
                fetch(`https://scratchdb.lefty.one/v2/forum/category/rank/${selectedCategory}/${page}`)
                .then(res => res.json())
                .then(data => {
                    /* modify webpage title */
                    if (selectedCategory != "total") {document.title = `${selectedCategory}: Scratch Forums Statistics`;}
                    /* delete loading text */
                    document.getElementById("loadingtext").remove();
                    let responsedata = data.users;
                    for (let j in responsedata)   {
                        if (responsedata[j].count == 0) {
                            break;
                        }
                        if (page == 0)  {
                            k = j;
                        } else  {
                            k = (100 * page) + Number(j);
                        }
                        console.log(responsedata[j]);
                        /* create div for user */
                        user = document.createElement("div");
                        user.setAttribute("id", `user${k}`);
                        user.setAttribute("class", "userbox");
                        var randomColor = HSVtoRGB(Math.random(), 0.5, 0.35);
                        user.setAttribute("style", "width: 0%;");
                        document.getElementById("content").appendChild(user);
                        /* create div for left located info */
                        info = document.createElement("div");
                        info.setAttribute("id", `info${k}`);
                        info.setAttribute("class", "info");
                        document.getElementById(`user${k}`).appendChild(info);
                        /* position */
                        categoryranking = document.createElement("div");
                        categoryranking.setAttribute("id", `categoryranking${k}`);
                        categoryranking.setAttribute("class", "categoryranking");
                        categoryranking.appendChild(document.createTextNode(responsedata[j].rank));
                        document.getElementById(`info${k}`).appendChild(categoryranking);
                        /* username */
                        username = document.createElement("a");
                        username.setAttribute("id", `username${k}`);
                        username.setAttribute("class", "username");
                        username.setAttribute("href", `user.html?user=${responsedata[j].username}`);
                        username.appendChild(document.createTextNode(responsedata[j].username));
                        document.getElementById(`info${k}`).appendChild(username);
                        /* create div for right located info */
                        extrainfo = document.createElement("div");
                        extrainfo.setAttribute("id", `extrainfo${k}`);
                        extrainfo.setAttribute("class", "extrainfo");
                        document.getElementById(`user${k}`).appendChild(extrainfo);
                        /* post count */
                        postcount = document.createElement("div");
                        postcount.setAttribute("id", `posts${k}`);
                        postcount.setAttribute("class", "userposts");
                        postcount.appendChild(document.createTextNode(responsedata[j].count));
                        document.getElementById(`extrainfo${k}`).appendChild(postcount);
                    }
                })
                .catch(function(){
                });
            }
            setInterval(animation => {
                for (j = 0; j < document.getElementsByClassName("userbox").length; j++)    {
                    var randomColor = "#1C1C1C";
                    document.getElementById(`user${j}`).style.transition = "width 1s";
                    document.getElementById(`user${j}`).style.width = `${document.getElementById(`posts${j}`).innerHTML / document.getElementById("posts0").innerHTML * 100}%`;
                    document.getElementById(`user${j}`).style.backgroundColor = `${randomColor}`;
                    document.getElementById(`user${j}`).style.padding = `5px ${window.innerWidth/50}px 5px ${window.innerWidth/50}px`;
                }
            },500);
            window.onscroll = () => {
                if ((window.innerHeight + window.scrollY) >= document.body.offsetHeight) {
                    currentpage++;
                    console.log("load page");
                    loadUserPosts(currentpage);
                }
            };
        </script>
    </body>
</html>